class MY_LIST_TEST

inherit MY_RANDOM
creation
   make, prim_test


feature
   a_list: MY_LIST[INTEGER];
   b_list: MY_LIST[INTEGER];

   eti: ARRAY[INTEGER] is
	  once
		 Result := << 1,2,3,4,5,6,7,8,9,0,-1,-2>>;
	  end;


   element: INTEGER
   
   
   make is
	  local
		 i, op, opc_mod: INTEGER
	  do
		 opc_mod:= 9;
		 set_seed(11291);
		 !!a_list.make;
		 from i := 0;
		 until i > 20
		 loop
			next_random;
			element := last_random \\ eti.count;
			next_random;
			op := last_random \\ opc_mod; 
			if op = 0 then
			   op := opc_mod;
			end;
			inspect op
			when 1 then
			   insert_last;
			when 2 then 
			   insert_first;
			when 3 then
			   insert_after;
			when 4 then
			   remove_element;
			when 5 then
			   if (i \\5 = 0 ) then
				  append;
			   end;
			   io.put_string("in when 5 then%N");
			when 6 then
			   if (i \\ 10 = 0) then
				  print_message(<<"clear a_list%N">>);
				  a_list.wipe_out;
			   end;
			   io.put_string("in when 6 then %N");
			when 7 then 
			   remove_all;
			when 8 then
			   go_i_th;
			when 9 then
			   count_occurences;
			end;
			if not a_list.empty then
			   print(a_list);
			end;
			io.put_string("Bitte enter drcken");
			io.read_character;
			i := i + 1;
		 end;
	  end;

   count_occurences is
	  do
		 print_message(<<" there are currently ", 
						 a_list.occurences(element), 
						 " from ", element, "%N">>); 
	  end;

   go_i_th is
	  local
		 where: INTEGER;
	  do
		 if a_list.count > 0 then
			next_random;
			where := last_random \\ a_list.count;
			if where = 0 then
			   where := a_list.count;
			end;
			print_message(<<"go to ", where, " element in list">>);
			a_list.go_i_th(where);
			check
			   a_list.i_th(where).item = a_list.item;
			end;
			io.put_string("check passed%N");
		 end;
	  end;
						

   remove_all is
	  do
		 print_message(<<"try to remove all elements equal to ", 
						 element, "%N">>);
		 a_list.remove_all_of(element);
	  end;
   
   append is
	  do
		 io.put_string("Wievile Element sollen in b_list eingetragen werden ?");
		 io.read_integer;
		 b_list := new_random_list(io.last_integer);
		 if b_list.count >= 1 then
			print_message(<<"append b_list to a_list%N">>);
			a_list.append(b_list);
		 else
			io.put_string("no elements in list%N");
		 end;
	  end;
   
   remove_element is
	  do
		 if not a_list.empty then
			print_message(<<"try to remove first ", element, "%N">>);
			a_list.remove(element);
		 end
	  end;				    
   
   
   insert_after is
	  local j : INTEGER;
	  do
		 if a_list.count > 0 then
			next_random;
			j :=  last_random \\ a_list.count;
			if j = 0 then
			   j := a_list.count;
			end;
			print_message(<< "insert_after(", element, ", ", j ,")%N">>);
			a_list.insert_after(element, j);
		 else
			io.put_string("a_list is empty, not possible to insert after any %
                          %element %N");
		 end;
	  end;
   
   insert_first is 
	  do
		 print_message(<<"insert_first(", element, ")%N">>);
		 a_list.insert_first(element);		 
	  end;


   insert_last is 
	  do
		 print_message(<<"insert_last(", element, ")%N">>);
		 a_list.insert_last(element);
	  end;

   print_message (an_array: ARRAY[ANY]) is 
	  local 
		 i : INTEGER;
	  do
		 from i := 1 
		 until i > an_array.count
		 loop
			print(an_array.item(i).out);
			i := i + 1;
		 end;
	  end;
			
   new_random_list(size_of_list: INTEGER): MY_LIST[INTEGER] is
	  local
		 i : INTEGER;
	  do
		 !!Result.make;
		 from i := 1 ;
		 until i > size_of_list
		 loop
			next_random;
			Result.insert_last(eti.item(last_random\\ eti.count +1));
			i := i + 1;
		 end;
	  end;

   prim_test is 
	  do
		 !!a_list.make;
		 -- a_list.insert_last(1);
		 a_list.insert_last(2);
		 a_list.insert_last(1);
		 a_list.insert_last(3);
		 a_list.insert_last(0);
		 --a_list.insert_last(4);
		 --a_list.insert_last(5);
		 --a_list.insert_last(4);
		 --a_list.insert_last(5);
		 a_list.insert_last(6);
		 -- a_list.remove_all_of(4);
		 --a_list.remove();
		 print(a_list);
		 a_list.remove(6);
		 print(a_list);
		 a_list.remove(3);
		 print(a_list);
		 --a_list.remove(2);
		 -- print(a_list);
		 --a_list.insert_first(3);
		 --print(a_list);
 -- b_list := a_list.slice(1,2);
		 --a_list.remove_all_of(4);
--		 a_list.remove(2);
		 a_list.remove_all_of(2);
		 -- a_list.remove(6);
		 print(a_list);
		 --a_list.insert_first(1);
		 --print(a_list);
-- 		 a_list.insert_first(4);
-- 		 a_list.insert_first(4);
-- 		 print(a_list);
-- 		 a_list.remove_all_of(4);
-- 		 print(a_list);
-- 		 a_list.insert_last(1);
-- 		 a_list.insert_last(2);
-- 		 a_list.insert_last(3);
-- 		 a_list.insert_last(3);
-- 		 !!b_list.make;
--    		 b_list.insert_last(1);
--    		 b_list.insert_last(2);
--  		 print(a_list);
--  		 b_list := clone(a_list);
-- 		 a_list.wipe_out;
--  		 a_list.append(b_list);
--  		 print(a_list);
--  		 a_list.insert_first(10);
--  		 a_list.insert_first(0);
--  		 a_list.insert_last(10);
-- 		 a_list.insert_last(10);
--  		 a_list.insert_last(4);
--  		 a_list.remove_all_of(2);
--  		 print(a_list);
-- 		 io.put_string("there are "); io.put_integer(a_list.occurences(1));
--  		 io.put_string(" 1s in a_list%N");
--  		 a_list.remove(1);
--  		 io.put_string("there are now "); io.put_integer(a_list.occurences(1));
--  		 io.put_string(" 1s in a_list");
-- 		 print(a_list);
-- 		 a_list.remove(1);
-- 		 a_list.remove(3);
-- 		 print(a_list);
-- 		 a_list.remove(4);
-- 		 a_list.remove(4);
-- 		 a_list.remove(10);
-- 		 a_list.remove(1);
-- 		 print(a_list);
-- 		 print(a_list);
-- 		 from a_list.go_first;
--  		 until a_list.off
--  		 loop
--  			a_list.insert_front(a_list.item);
--  			print(a_list);
--  			a_list.go_next;
--  		 end;
--  		 a_list.insert_last(3);
--  		 a_list.insert_last(4);
-- 		 a_list.go_i_th(2);
-- 		 io.put_string("item = ");
-- 		 print(a_list.item);
--  		 print(a_list.next);
--  		 io.put_string("i_th_element(2).item = ");
-- 		 print(a_list.i_th_element(2).item);
--  		 a_list.insert_after(5, 1);
--  		 a_list.insert_after(6, a_list.count);
--  		 a_list.insert_after(7, 1);
--  		 print(a_list);
	  end;
   
end -- class MY_LIST_TEST
