--
-- SUMMARY:      
--
-- AUTHOR:       Friedrich Dominicus
-- ORG:          No Org
-- ORIG-DATE:    16-Jun-99 at 11:41:09
-- LAST-MOD:     23-Jun-99 at 19:53:47 by Friedrich Dominicus
-- DESCRIPTION:  
-- DESCRIP-END.


   
class MY_RANDOM

   
feature
   last_random: INTEGER;
   
   next_random is
	  do
		 last_random := c_rand;
	  end;

   set_seed (new_seed: INTEGER) is
	  do
		 c_srand(new_seed);
	  end;
   
   set_random_seed is
	  do 
		 c_set_random_seed;
	  end;
   
   get_random_seed: INTEGER is
	  do
		 Result := c_get_random_time_seed;
	  end;

feature{NONE}
   
   c_rand : INTEGER is
	  external "C"
	  end;

   c_srand (seed: INTEGER) is
	  external "C"
	  end;	
   
   c_set_random_seed is
	  external "C"
	  end;

   c_get_random_time_seed: INTEGER is
	  external "C"
	  end;
	  

end
   
